/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/
//
//
//	WBT学習開始URL作成クラス
//			変更履歴
//				2004.01.08	新規作成	五木田 泰史
//

package jp.co.ntt.lms.lo.WBT;

import java.util.Hashtable;
import java.util.Vector;
import java.net.URLEncoder;
import java.io.UnsupportedEncodingException;
import java.sql.SQLException;

import jp.co.ntt.lms.lo.*;
import jp.co.ntt.lms.lo.WBT.util.CertificationCipher;
import jp.co.ntt.lms.xmo.DataAccess;
import jp.co.ntt.lms.xmo.util.*;

/**
 * WBT学習開始URL作成クラス
 *
 * <PRE>
 *   WbtLoの学習開始URLを作成する。
 *   上位に学習開始URL作成インタフェースクラスを持つ。
 * </PRE>
 *
 */
public class WbtLoURLMaker
	implements LoPropertyDef
{

	private static final String FILE_EXTENSION = ".xml";

	/**
	 * WBT学習開始URL作成
	 *
	 * @param Hashtable パラメータリスト
	 * @return String WBT学習開始URL
	 * @exception LOException Lo固有の例外エラー
	 */
	public String makeStartLearnURL(Hashtable htbParam, DataAccess objDataAccess)
		throws LOException, UnsupportedEncodingException
	{
		try
		{
			// WBT教材詳細情報を設定します
			setWbtLoData( htbParam );
			
			// WBT教材環境クラスのインスタンス化
			WbtLoEnv objEnv     = new WbtLoEnv();

			// ユーザIDの取得
			String strUserID = (String)htbParam.get( USER );

			// 教材IDの取得
			String strMaterialID = (String)htbParam.get( MATLID );
			// ファイル名を生成
			String strMaterialFileName = strMaterialID + "/" + strMaterialID + FILE_EXTENSION;
			// 教材URLを取得する
			String strMaterialURL = objEnv.getMaterialURL( strMaterialFileName );
			// 暗証キーを取得
			String strXmsKey = CertificationCipher.encode( strUserID, strMaterialURL );

			// セッションIDの設定
			String strLoID = (String)htbParam.get( LOID );
			if( strLoID != null ) {
				htbParam.put( SESSIONID, strLoID );
			}

			// 戻り値初期化
			String strRet       = "";
			// 戻りURL初期化
			String strReturnURL = "";

			// 戻りURLをEndLearnServletにする
			strReturnURL        = objEnv.getEndLearnServletURL();
			// 戻りページのエンコード
			strReturnURL        = URLEncoder.encode(strReturnURL, "UTF-8");

			// 戻りURLの再設定
			htbParam.put(RETURN_URL, strReturnURL);

			// XMSKeyを設定
			htbParam.put( objEnv.XMS_KEY, strXmsKey );

			// 教材URLの設定
			htbParam.put( objEnv.MATERIAL_URL, URLEncoder.encode( strMaterialURL, "UTF-8") );

			// LoLogSessionデータ存在チェック
			LoLogSessionDataAccess objLsda = new LoLogSessionDataAccess();
			String[] strStudyDateList = objLsda.getStudyDateList(strUserID, strLoID, objDataAccess);
			String strMaxStartDate = strStudyDateList[0];			// 最新学習開始日取得
			String strMaxEndDate = strStudyDateList[1];				// 最新学習完了日取得
			if(strMaxStartDate == null || strMaxStartDate.equals(""))
			{
				// 最新学習開始日がNULLまたは空文字ならば
				htbParam.put(objEnv.COMD, objEnv.COMD_NEW);
			} else {
				// 最新学習完了日がNULLまたは空文字以外ならば
				htbParam.put(objEnv.COMD, objEnv.COMD_CONT);
			}

			strRet = objEnv.getLearnURL(htbParam);

			return strRet;
		}
		catch(LOException le)
		{
			throw le;
		}
		catch(SQLException se ) {
			DebugLog.write( this.getClass(), se, DebugLog.HIGHT );
			throw new LOException( se.getMessage() );
		}
		catch(UnsupportedEncodingException e) {
			throw e;
		}	
	}

	/**
	 * WBT教材詳細情報を設定します
	 */
	private void setWbtLoData( Hashtable htbParam )
		throws LOException
	{

		// Dataアクセスクラスを使用して、詳細情報を取得する
		WbtLoDataAccess objDataAccess = new WbtLoDataAccess();
		WbtLoData[] objData = objDataAccess.getData( htbParam );

		for( int i = 0; i < objData.length; i++ ) {
			// ハッシュに必要な項目を設定
			// 教材IDの設定
			htbParam.put( MATLID, objData[i].getMaterialID() );
		}
	}
}

